// Generated by CoffeeScript 1.6.3
var checkModified, exec, fs, path;

exec = require('executive');

fs = require('fs');

path = require('path');

checkModified = function(src, dst, cb) {
  return fs.stat(src, function(err, stat) {
    var mtime;
    if (err) {
      return cb(err);
    }
    mtime = stat.mtime;
    return fs.stat(dst, function(err, stat) {
      if (err) {
        return cb(err);
      }
      return cb(mtime > stat.mtime);
    });
  });
};

module.exports = {
  mappings: {
    coffee: 'js',
    jade: 'html',
    styl: 'css'
  },
  compile: function(filename) {
    var compiler, dst, ext, src;
    ext = (path.extname(filename)).substr(1);
    if ((compiler = this[ext]) == null) {
      return false;
    }
    src = filename;
    dst = filename.replace(new RegExp(ext + '$'), this.mappings[ext]);
    checkModified(src, dst, function(newer) {
      var cmd;
      if (!newer) {
        return;
      }
      if (typeof (cmd = compiler(src, dst)) === 'string') {
        return exec.quiet(cmd, function(err, stdout, stderr) {
          if ((stderr = stderr.trim()) !== '') {
            return console.error(stderr);
          }
        });
      }
    });
    return true;
  },
  coffee: function(src, dst) {
    dst = path.dirname(dst);
    return "coffee -bc -o " + dst + " " + src;
  },
  jade: function(src, dst) {
    dst = path.dirname(dst);
    return "jade " + src + " --out " + dst;
  },
  styl: function(src, dst) {
    dst = path.dirname(dst);
    return "stylus " + src + " -o " + dst;
  }
};

/*
//@ sourceMappingURL=compilers.map
*/
